From 50911a16240042d0e16178a056d6e66d41d95700 Mon Sep 17 00:00:00 2001
From: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Date: Tue, 17 Feb 2026 16:51:20 +0530
Subject: [PATCH v20260813 1/2] Resizable shared memory structures

Resizable shared memory structures can be requested by specifying a new
member ShmemStructOpts::maximum_size. At the startup or when the
structure is created, we reserve address space worth maximum_size in the
shared memory segment. It is expected that the subsystem which creates a
resizable structure would initialize only the memory worth its initial
size given by ShmemStructOpts::maximum_size when creating it. In an
mmap'ed memory, this should allocate memory worth only the initial size.
It should not allocate maximum_size worth of memory initially. As the
structure is resized using ShmemResizeStruct() memory is freed or
allocated in chunks of memory pages when shrinking and expanding the
structure respectively. Optional ShmemStructOpts::minimum_size
specification for resizable shared memory structures allows us to
enforce that a resizable structure cannot be shrunk below a certain
size. If minimum_size is not specified for a resizable structure, it the
minimum size defaults to 0. Two additional columns are added to
pg_shmem_allocations view to report minimum and maximum size
respectively.

The structure for which ShmemStructOpts::maximum_size is not specified
or is set to 0 is considered as a fixed size structure.  Existing calls
to ShmemRequestStruct() requsting fixed size structures need no change.
For fixed-size structures, the minimum size and maximum size are set to
the initial size specified in ShmemRequestStructOpts::size. This makes
maximum size and minimum size reported in pg_shmem_allocations view
semantically consistent for both fixed-size and resizable structures. As
a side effect, a request which specifies same minimum_size and
maximum_size will be treated as a fixed size structure.

Minimum, maximum and initial sizes of main shared memory area
=============================================================

With the addition of resizable shared structures, the main shared memory
area has three sizes to be tracked:
 - a. the minimum amount of shared memory that will always be needed
 - b. the maximum amount of shared memory that may be allocated when all
   the resizable structures have grown to their maximum size. It is also
   is the size of the address space reserved for the main shared memory
   area.
 - c. the amount of memory allocated at the server startup i.e. initial
   allocation.

mmap needs to use the maximum size to reserve enough address space to
accomodate all the shared structures. But a DBA may provision only the
memory required at the startup initially and increase or descrease the
memory provision as the demand changes.

These three sizes are reported as GUCs shared_memory_minimum_size,
shared_memory_maximum_size and shared_memory_initial_size respectively.
They replace the old GUC shared_memory_size which used to report both
size of the main shared memory area and amount of memory required in it.
Since these two things are not the same anymore, a single GUC is not
sufficient.  These GUCs help DBAs to estimate memory to be provisioned
at the startup and during run time as the resizable structures change
their sizes.

Portability
===========

Resizable shared structures feature depends upon existence of function
madvise() and constants MADV_REMOVE and MADV_WRITE_POPULATE.  On the
platforms which do not have these or the shared memory types (e.g.
Sys-V) which do not provide ability to free or allocate parts of shared
memory, we disable this feature. A run time GUC have_resizable_shmem
indicates whether a running server supports resizable structures or not.

The commit introduces a compile time flag HAVE_RESIZABLE_SHMEM which is
defined if MADV_REMOVE and MADV_WRITE_POPULATE exist. We don't check
existence of madvise separately, since existence of the constants
implies existence of the function. HAVE_RESIZABLE_SHMEM is not defined
in EXEC_BACKEND builds since that's largely used for Windows where the
APIs to free and allocate memory from and to a given address space are
not known to the author right now. Given that PostgreSQL is used widely
on Linux (with shared memory type mmap), providing this feature on Linux
benefits most of its users.  Once we figure out the required Windows
APIs, we will support this feature on Windows as well.

Prohibiting access to the unused portion of a resizable structure
================================================================

We provide ShmemProtectStruct() to add protections on the address space
reserved for a resizable shared memory structure so that the address
space upto its current size is accessible whereas the part beyond that
is inaccessible. Since these protections are backend specific, the
subsystem using the resizable shared memory structures has to make sure
to call ShmemProtectStruct() after every resize before any backend tries
to access the portion of the structure between old and the new size.
This can coordinated using ProcSignalBarrier mechanism in a running
backend. When starting the server, Postmaster adds appropriate
protections when creating these structures. In an EXEC_BACKEND case,
when a backend starts, the protections are added according to the
current size of the backend (through attach_fn call). However, in
non-EXEC_BACKEND case, a new backend inherits stale protections from the
postmaster. It needs to apply the protections according to the current
sizes of these structures.

Following points need more discussion.

Discussion points
=================

adding initial protections in non-EXEC_BACKEND case
----------------------------------------------------------------------
When a backend starts, it needs to add shmem protections it in such a
way that a ProcSignalBarrier conveying the protection change is not
missed. Hence we do it along side InitLocalDataChecksumState(). This has
two problems 1. it delays backend startup process and 2. it loosely ties
resizable shared memory structure to ProcSignalBarrier mechanim. Do we
consider the complexity worth it?  Is there any other way to do it
without these two drawbacks?

Further, we call ShmemReprotectResizableStructs() twice in the startup
sequence, once immediately after the place where
AttachSharedMemoryStructs() would be called in EXEC_BACKEND case and
then second time after ProcSignalInit(). The first one is needed so that
the processes can access the resizable structures safely. The second is
needed for the reasons mentioned there. But a change in the protection
during these calls will be missed by the backend and thus lead to
hazardous access. Can we avoid it? If ProcSignalInit() were to be called
nearer to the InitProcess(), it may make calling
ShmemReprotectResizeStructs() easier.

Protection in the resizing backend vs other backends
----------------------------------------------------
The patch provides an API to protect the address spaces not used because
of current size of the resizable structures in every backend. Since
every backend has to protect its own address space, a separate API is
required. But at the same time, in some cases the resize operation
itself needs to change the protection (e.g. when expanding the
structure). So there's some asymmetry between the moment when the
resizing backend adds protection and when other backends add it. That
doesn't affect end result since adding this protection is an idempotent
operation. But still there's some ugliness involved. This part also
needs more discussion.

HAVE_RESIZABLE_SHMEM and have_resizable_shmem
---------------------------------------------
The patch defines a build time macro HAVE_RESIZABLE_SHMEM to avoid
compilation failure on a build platform where the required system calls
or constants are not available. But we also need a run time check to see
whether the shared memory type being used allows resizing. Hence we
provide a GUC have_resizable_shmem which tells whether a running server
supports resizable shared memory or not. Most of the code which deals
with the shared memory is under HAVE_RESIZABLE_SHMEM, but there is some
related to resizable shared memory outside the macro as well. For
example, the members maximum_size, minimum_size are not under this
macro. This is mostly to allow writing readable code in both the modes
and still provide the same user visible views etc. This division of code
within and without macro needs more discussion.

TODOs
=====
There are some TODOs in the code still. We will address them as we
finalize that part of design/code. Comments/suggestions on those is
welcome.

Idea of using mmap to reserve address space in shared memory segments
and allocating memory within that address space on demand was proposed
by Dmitry Dolgov <9erthalion6@gmail.com>.

Author: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Reviewed-by: Matthias van de Meent <boekewurm+postgres@gmail.com>
---
 configure.ac                                  |   4 +
 doc/src/sgml/config.sgml                      | 102 +++-
 doc/src/sgml/ref/postgres-ref.sgml            |   8 +-
 doc/src/sgml/runtime.sgml                     |   9 +-
 doc/src/sgml/system-views.sgml                |  57 +-
 doc/src/sgml/xfunc.sgml                       |  92 +++
 meson.build                                   |  16 +
 src/backend/port/sysv_shmem.c                 | 259 +++++++-
 src/backend/port/win32_shmem.c                |  64 +-
 src/backend/postmaster/auxprocess.c           |  46 +-
 src/backend/storage/ipc/ipci.c                | 114 ++--
 src/backend/storage/ipc/shmem.c               | 555 ++++++++++++++++--
 src/backend/storage/lmgr/proc.c               |  16 +
 src/backend/utils/init/postinit.c             |  10 +
 src/backend/utils/misc/guc_parameters.dat     |  57 +-
 src/backend/utils/misc/guc_tables.c           |  15 +-
 src/include/catalog/pg_proc.dat               |   4 +-
 src/include/pg_config.h.in                    |   8 +
 src/include/pg_config_manual.h                |  14 +
 src/include/storage/ipc.h                     |   2 +-
 src/include/storage/pg_shmem.h                |   6 +-
 src/include/storage/shmem.h                   |  19 +
 src/include/storage/shmem_internal.h          |   2 +-
 src/test/modules/test_shmem/meson.build       |   3 +-
 ...mem_alloc.pl => 001_fixed_shmem_struct.pl} |  31 +
 .../t/002_resizable_shmem_struct.pl           | 382 ++++++++++++
 .../modules/test_shmem/test_shmem--1.0.sql    |  55 ++
 src/test/modules/test_shmem/test_shmem.c      | 504 +++++++++++++++-
 src/test/regress/expected/rules.out           |   7 +-
 src/tools/pgindent/typedefs.list              |   1 +
 30 files changed, 2294 insertions(+), 168 deletions(-)
 rename src/test/modules/test_shmem/t/{001_late_shmem_alloc.pl => 001_fixed_shmem_struct.pl} (58%)
 create mode 100644 src/test/modules/test_shmem/t/002_resizable_shmem_struct.pl

diff --git a/configure.ac b/configure.ac
index a331749fcb5..bba12b8c8f4 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1912,6 +1912,10 @@ AC_CHECK_DECLS([memset_s], [], [], [#define __STDC_WANT_LIB_EXT1__ 1
 # This is probably only present on macOS, but may as well check always
 AC_CHECK_DECLS(F_FULLFSYNC, [], [], [#include <fcntl.h>])
 
+# Linux-specific madvise constants needed for resizable shared memory. See similar checks in meson.build for explanation of why these checks are here.
+AC_CHECK_DECLS([MADV_POPULATE_WRITE], [], [], [#include <sys/mman.h>])
+AC_CHECK_DECLS([MADV_REMOVE], [], [], [#include <sys/mman.h>])
+
 AC_REPLACE_FUNCS(m4_normalize([
 	explicit_bzero
 	getopt
diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index aa7b1bd75d2..5b6cc870093 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -12373,6 +12373,20 @@ dynamic_library_path = '/usr/local/lib/postgresql:$libdir'
       </listitem>
      </varlistentry>
 
+     <varlistentry id="guc-have-resizable-shmem" xreflabel="have_resizable_shmem">
+      <term><varname>have_resizable_shmem</varname> (<type>boolean</type>)
+      <indexterm>
+       <primary><varname>have_resizable_shmem</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Reports whether <productname>PostgreSQL</productname> supports <link
+        linkend="xfunc-shared-addin-resizable">Resizable shared memory structures</link>.
+       </para>
+      </listitem>
+     </varlistentry>
+
      <varlistentry id="guc-huge-pages-status" xreflabel="huge_pages_status">
       <term><varname>huge_pages_status</varname> (<type>enum</type>)
       <indexterm>
@@ -12552,32 +12566,100 @@ dynamic_library_path = '/usr/local/lib/postgresql:$libdir'
       </listitem>
      </varlistentry>
 
-     <varlistentry id="guc-shared-memory-size" xreflabel="shared_memory_size">
-      <term><varname>shared_memory_size</varname> (<type>integer</type>)
+     <varlistentry id="guc-shared-memory-initial-size" xreflabel="shared_memory_initial_size">
+      <term><varname>shared_memory_initial_size</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>shared_memory_initial_size</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Reports the amount of memory, rounded up to the nearest megabyte, allocated at the server startup in main shared memory area.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="guc-shared-memory-minimum-size" xreflabel="shared_memory_minimum_size">
+      <term><varname>shared_memory_minimum_size</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>shared_memory_minimum_size</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Reports the minimum amount of memory, rounded up to the nearest megabyte, required in the main shared memory area.
+      </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="guc-shared-memory-maximum-size" xreflabel="shared_memory_maximum_size">
+      <term><varname>shared_memory_maximum_size</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>shared_memory_maximum_size</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Reports the maximum size of the main shared memory area, rounded up
+        to the nearest megabyte. This is the amount of address space that
+        must be reserved for the main shared memory area. This is also the maximum amount of memory that may be allocated in the main shared memory area.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="guc-shared-memory-initial-size-in-huge-pages" xreflabel="shared_memory_initial_size_in_huge_pages">
+      <term><varname>shared_memory_initial_size_in_huge_pages</varname> (<type>integer</type>)
       <indexterm>
-       <primary><varname>shared_memory_size</varname> configuration parameter</primary>
+       <primary><varname>shared_memory_initial_size_in_huge_pages</varname> configuration parameter</primary>
       </indexterm>
       </term>
       <listitem>
        <para>
-        Reports the size of the main shared memory area, rounded up to the
-        nearest megabyte.
+        Reports the number of huge pages needed in the main shared memory area
+        at the startup based on the specified <xref
+        linkend="guc-huge-page-size"/>. If huge pages are not supported, this
+        will be <literal>-1</literal>.
+       </para>
+       <para>
+        This setting is supported only on <productname>Linux</productname>. It
+        is always set to <literal>-1</literal> on other platforms. For more
+        details about using huge pages on <productname>Linux</productname>, see
+        <xref linkend="linux-huge-pages"/>.
        </para>
       </listitem>
      </varlistentry>
 
-     <varlistentry id="guc-shared-memory-size-in-huge-pages" xreflabel="shared_memory_size_in_huge_pages">
-      <term><varname>shared_memory_size_in_huge_pages</varname> (<type>integer</type>)
+     <varlistentry id="guc-shared-memory-minimum-size-in-huge-pages" xreflabel="shared_memory_minimum_size_in_huge_pages">
+      <term><varname>shared_memory_minimum_size_in_huge_pages</varname> (<type>integer</type>)
       <indexterm>
-       <primary><varname>shared_memory_size_in_huge_pages</varname> configuration parameter</primary>
+       <primary><varname>shared_memory_minimum_size_in_huge_pages</varname> configuration parameter</primary>
       </indexterm>
       </term>
       <listitem>
        <para>
-        Reports the number of huge pages that are needed for the main shared
-        memory area based on the specified <xref linkend="guc-huge-page-size"/>.
+        Reports the minimum number of huge pages needed in the main shared memory area based on the specified <xref linkend="guc-huge-page-size"/>.
         If huge pages are not supported, this will be <literal>-1</literal>.
        </para>
+       <para>
+        This setting is supported only on <productname>Linux</productname>.  It
+        is always set to <literal>-1</literal> on other platforms.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="guc-shared-memory-maximum-size-in-huge-pages" xreflabel="shared_memory_maximum_size_in_huge_pages">
+      <term><varname>shared_memory_maximum_size_in_huge_pages</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>shared_memory_maximum_size_in_huge_pages</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Reports the maximum number of huge pages needed in the
+        main shared memory area based on the specified
+        <xref linkend="guc-huge-page-size"/>. If huge pages are not
+        supported, this will be <literal>-1</literal>.
+       </para>
        <para>
         This setting is supported only on <productname>Linux</productname>.  It
         is always set to <literal>-1</literal> on other platforms.  For more
diff --git a/doc/src/sgml/ref/postgres-ref.sgml b/doc/src/sgml/ref/postgres-ref.sgml
index b13a16a117f..3eefd629e06 100644
--- a/doc/src/sgml/ref/postgres-ref.sgml
+++ b/doc/src/sgml/ref/postgres-ref.sgml
@@ -143,8 +143,12 @@ PostgreSQL documentation
        <para>
         This can be used on a running server for most parameters.  However,
         the server must be shut down for some runtime-computed parameters
-        (e.g., <xref linkend="guc-shared-memory-size"/>,
-        <xref linkend="guc-shared-memory-size-in-huge-pages"/>, and
+        (e.g., <xref linkend="guc-shared-memory-initial-size"/>,
+        <xref linkend="guc-shared-memory-minimum-size"/>,
+        <xref linkend="guc-shared-memory-maximum-size"/>,
+        <xref linkend="guc-shared-memory-initial-size-in-huge-pages"/>,
+        <xref linkend="guc-shared-memory-minimum-size-in-huge-pages"/>,
+        <xref linkend="guc-shared-memory-maximum-size-in-huge-pages"/>, and
         <xref linkend="guc-wal-segment-size"/>).
        </para>
 
diff --git a/doc/src/sgml/runtime.sgml b/doc/src/sgml/runtime.sgml
index d9984910cc4..8ba4d233509 100644
--- a/doc/src/sgml/runtime.sgml
+++ b/doc/src/sgml/runtime.sgml
@@ -1450,11 +1450,12 @@ export PG_OOM_ADJUST_VALUE=0
     <varname>CONFIG_HUGETLB_PAGE=y</varname>. You will also have to configure
     the operating system to provide enough huge pages of the desired size.
     The runtime-computed parameter
-    <xref linkend="guc-shared-memory-size-in-huge-pages"/> reports the number
-    of huge pages required.  This parameter can be viewed before starting the
+    <xref linkend="guc-shared-memory-maximum-size-in-huge-pages"/> reports the
+    number of huge pages that must be available in the pool for postmaster
+    startup to succeed.  This parameter can be viewed before starting the
     server with a <command>postgres</command> command like:
 <programlisting>
-$ <userinput>postgres -D $PGDATA -C shared_memory_size_in_huge_pages</userinput>
+$ <userinput>postgres -D $PGDATA -C shared_memory_maximum_size_in_huge_pages</userinput>
 3170
 $ <userinput>grep ^Hugepagesize /proc/meminfo</userinput>
 Hugepagesize:       2048 kB
@@ -1465,7 +1466,7 @@ hugepages-1048576kB  hugepages-2048kB
      In this example the default is 2MB, but you can also explicitly request
      either 2MB or 1GB with <xref linkend="guc-huge-page-size"/> to adapt
      the number of pages calculated by
-     <varname>shared_memory_size_in_huge_pages</varname>.
+     <varname>shared_memory_maximum_size_in_huge_pages</varname>.
 
      While we need at least <literal>3170</literal> huge pages in this example,
      a larger setting would be appropriate if other programs on the machine
diff --git a/doc/src/sgml/system-views.sgml b/doc/src/sgml/system-views.sgml
index 5ea19d68622..8f0d66b8b4a 100644
--- a/doc/src/sgml/system-views.sgml
+++ b/doc/src/sgml/system-views.sgml
@@ -4244,8 +4244,46 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
        Size of the allocation in bytes including padding. For anonymous
        allocations, no information about padding is available, so the
        <literal>size</literal> and <literal>allocated_size</literal> columns
-       will always be equal. Padding is not meaningful for free memory, so
-       the columns will be equal in that case also.
+       will always be equal. Padding is not meaningful for free memory, so the
+       columns will be equal in that case also. For resizable allocations which
+       may span multiple memory pages, the padding includes the padding due to
+       page alignment.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>minimum_size</structfield> <type>int8</type>
+      </para>
+      <para>
+       Minimum size in bytes that the resizable allocation can shrink to. Equals
+       <structfield>size</structfield> for fixed-size allocations, anonymous
+       allocations, and free memory.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>maximum_size</structfield> <type>int8</type>
+      </para>
+      <para>
+       Maximum size in bytes that the resizable allocation can grow to. Equals
+       <structfield>size</structfield> for fixed-size allocations, anonymous
+       allocations, and free memory.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>reserved_space</structfield> <type>int8</type>
+      </para>
+      <para>
+       Address space reserved for the allocation in bytes. For resizable
+       structures, this is the total address space reserved to accommodate
+       growth up to <structfield>maximum_size</structfield>, and is greater
+       than or equal to <structfield>allocated_size</structfield>. For
+       fixed-size allocations, anonymous allocations, and free memory this
+       is same as <structfield>allocated_size</structfield>.
       </para></entry>
      </row>
     </tbody>
@@ -4259,6 +4297,21 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
    <literal>ShmemRequestHash()</literal>.
   </para>
 
+  <para>
+   Resizable structures are allocations whose size can change while the server
+   is running. <xref linkend="guc-have-resizable-shmem"/> indicates whether the
+   running server supports resizable allocations. Each such allocation has a
+   minimum size give by <structfield>minimum_size</structfield> it can shrink to
+   and a maximum size given by <structfield>maximum_size</structfield> it can
+   grow to; enough address space is reserved up front to accommodate its
+   <structfield>maximum_size</structfield>.  The aggregate initial, minimum and
+   maximum sizes of all shared memory allocations are reported by <xref
+   linkend="guc-shared-memory-initial-size"/>, <xref
+   linkend="guc-shared-memory-minimum-size"/> and <xref
+   linkend="guc-shared-memory-maximum-size"/> respectively (and their
+   <literal>_in_huge_pages</literal> counterparts).
+  </para>
+
   <para>
    By default, the <structname>pg_shmem_allocations</structname> view can be
    read only by superusers or roles with privileges of the
diff --git a/doc/src/sgml/xfunc.sgml b/doc/src/sgml/xfunc.sgml
index 2b8a11e7ad0..2bfc664d7ca 100644
--- a/doc/src/sgml/xfunc.sgml
+++ b/doc/src/sgml/xfunc.sgml
@@ -3744,6 +3744,98 @@ my_shmem_init(void *arg)
      </para>
     </sect3>
 
+    <sect3 id="xfunc-shared-addin-resizable">
+     <title>Resizable shared memory structures</title>
+
+     <para>
+     A resizable memory structure can be requested using
+     <function>ShmemRequestStruct</function> by passing
+     <parameter>.maximum_size</parameter> along with
+     <parameter>.size</parameter>. <parameter>.maximum_size</parameter> is
+     maximum size upto which the structure can grow where as
+     <parameter>.size</parameter> is the initial size of the structure.
+     Optionally, <parameter>.minimum_size</parameter> can be set to the minimum
+     size that the structure can shrink to.  While
+     contiguous address space worth <parameter>maximum_size</parameter> is
+     allocated to the structure, only memory worth <parameter>size</parameter>
+     bytes is allocated initially. The <function>init_fn</function> should only
+     initialize the <parameter>size</parameter> amount of memory. The actual
+     memory allocated to this structure at any point in time is given by <link
+     linkend="view-pg-shmem-allocations"><structname>pg_shmem_allocations</structname>.<structfield>allocated_size</structfield></link>
+     and the address space reserved for this structure is given by <link
+     linkend="view-pg-shmem-allocations"><structname>pg_shmem_allocations</structname>.<structfield>reserved_space</structfield></link>.
+     </para>
+
+    <para>
+    The structure can be resized using <function>ShmemResizeStruct</function> by
+    passing it the structure's name and the
+    new size which can be anywhere between <parameter>minimum_size</parameter>
+    and <parameter>maximum_size</parameter>. If the new size is smaller than the
+    current size of the structure, the memory between the new size and current
+    size is freed while keeping the contents of the memory upto new size intact.
+    If the new size is greater than the current size, memory is allocated upto
+    new size while keeping the current contents of the structure intact. The
+    starting address of the structure does not change because of resizing
+    operation.
+    </para>
+
+    <para>
+    <function>ShmemResizeStruct</function> returns <literal>true</literal> on
+    success. If the operating system cannot supply the additional memory
+    required to expand the structure, it emits a <literal>WARNING</literal>
+    naming the structure and the number of bytes that could not be allocated,
+    leaves the structure at its previous size, and returns
+    <literal>false</literal>.
+    </para>
+
+    <para>
+    <function>ShmemResizeStruct</function> does not coordinate with other
+    backends that may be accessing the shared structure. The caller is
+    responsible for ensuring that no backend is accessing the parts of the
+    structure between old size and the new size while
+    <function>ShmemResizeStruct</function> is executing. Similarly after the
+    function has finished, the caller must ensure that each backend knows the
+    new size before accessing the parts of the structure between the old size
+    and the new size. Accessing the range <literal>[current_size,
+    maximum_size)</literal> results in an undefined operating-system dependent
+    behaviour.
+    </para>
+
+    <para>
+    <function>ShmemProtectStruct</function> can be used to make the range beyond
+    the current size inaccessible in a backend's address space, so that stray
+    accesses cause a fault instead of silently succeeding. When a backend
+    starts, protections for all resizable structures are adjusted according to
+    their current sizes, so subsystems need not call
+    <function>ShmemProtectStruct</function> from their per-backend
+    initialization routines. During runtime after calling
+    <function>ShmemResizeStruct</function> from one backend,
+    <function>ShmemProtectStruct</function> should be called from all the
+    backends that may access the structure.
+    </para>
+
+    <para>
+    <productname>PostgreSQL</productname>'s
+    <function>ProcSignalBarrier</function> mechanism (see
+    <filename>src/include/storage/procsignal.h</filename>) may be used to
+    coordinate the resize across backends and adjusting access to the address
+    space.
+    </para>
+
+    <para>
+    This functionality is available only on the platforms which provide the APIs
+    necessary to reserve contiguous address space and to allocate or free memory
+    in that address space on demand. Macro <symbol>HAVE_RESIZABLE_SHMEM</symbol>
+    is defined on such platforms. It can be used to guard code related to
+    resizing a shared memory structure. The functionality is available on with
+    mmap'ed memory, so subsystems which use resizable structures may have to
+    addtionally disable resizable memory usage when <symbol>shared_memory_type</symbol> is not
+    <symbol>SHMEM_TYPE_MMAP</symbol>. A GUC <xref linkend="guc-have-resizable-shmem"/> is set to
+    <literal>on</literal> when this functionality is available in a running
+    server, <literal>off</literal> otherwise.
+    </para>
+    </sect3>
+
     <sect3 id="xfunc-shared-addin-dynamic">
      <title>Allocating Dynamic Shared Memory after Startup</title>
 
diff --git a/meson.build b/meson.build
index f4cde249242..4e0c736470c 100644
--- a/meson.build
+++ b/meson.build
@@ -2894,6 +2894,22 @@ decl_checks = [
   ['timingsafe_bcmp',  'string.h'],
 ]
 
+# Linux-specific madvise constants needed for resizable shared memory.
+# Usually we use AC_CHECK_DECLS to check for function declarations, but in this
+# case we are using it to detect existence of constants. These constants are
+# used to define HAVE_RESIZABLE_SHMEM which is used in storage/pg_shmem.h as
+# well as storage/shmem.h. The first abstracts the APIs to allocate shared
+# memory segments from the operating system whereas the second abstracts APIs to
+# allocate shared memory to various subsystems. Since they are related but
+# orthogonal to each other, including any one of them in the other file doesn't
+# make sense. pg_config_manual.h is the only place where HAVE_RESIZABLE_SHMEM
+# can be defined and made available to both without including sys/mman.h. But
+# for that we need constants that indicate the existence of following defines.
+decl_checks += [
+  ['MADV_POPULATE_WRITE', 'sys/mman.h'],
+  ['MADV_REMOVE', 'sys/mman.h'],
+]
+
 # Need to check for function declarations for these functions, because
 # checking for library symbols wouldn't handle deployment target
 # restrictions on macOS
